Module ExNVMemRead

    Sub Main()
        Dim n As Long
        Dim tmp As Byte
        Dim stmp As String

        ZeroMemory(PassTbl, 16 * PASS_NO, 0)

        n = 0
        While n < PASS_NO
            stmp = "Pass" & n
            For tmp = 0 To Len(stmp) - 1
                PassTbl(n * 16 + tmp) = Asc(Mid(stmp, tmp + 1, 1))
            Next
            n = n + 1
        End While

        StartProlog()

        ' zainicjowanie OutKey
        OutKey = (GetTickCount() And &HFFFFFF00) Or &HF00

        ' odczyt pamici TeleTokenu
        Console.WriteLine("Odczyt pamieci TeleTokenu:")

        n = 0
        While (n < TokenInfoTbl(TVTTTI_NV_MEM_SIZE))
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)

            OutKey = OutKey + 1                                                                 ' zwikszenie licznika kluczy

            OutDataB(TVTTD_CMD) = TVTTC_NVMEM_READ                                              ' rozkaz odczytu pamici TeleTokenu
            OutDataB(TVTTD_PARAM1) = n                                                          ' numer sektora do odczytania


            TVTT_CalcAuth(OutDataA, OutDataB)                                                   ' policzenie bloku kontrolnego
            TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T)              ' zaszyfrowanie pierwszego bloku danych
            TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T)              ' zaszyfrowanie drugiego bloku danych
            Status = TVTT_Talk(TokenH, 2, OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
            TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC)                ' rozszyfrowanie pierwszego bloku danych
            TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC)                ' rozszyfrowanie drugiego bloku danych


            If (Status <> 0) Then
                Console.Write(vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex(Status And &HFF, 2))
                Exit While
            End If

            If (TVTT_CheckAuth(InDataA, InDataB) <> 0) Then
                Console.Write(vbTab & "Blad bloku kontrolnego!")
                Exit While
            End If

            If (InDataB(TVTTD_STATUS) <> 0) Then
                Console.WriteLine(vbTab & IntToHex(InDataB(TVTTD_STATUS), 2))
                Exit While
            End If

            If (InKey = 0) Then
                Console.WriteLine(vbTab & "Wiamosc nie zaszyfrowana!")                          ' sprawdzenie czy wiamo zaszyfrowana                
                Exit While
            End If

            Console.Write(vbTab + IntToHex(n, 2) + ":")
            Print16(InDataA)
            n = n + 1
        End While

        If (n = TokenInfoTbl(TVTTTI_NV_MEM_SIZE)) Then Console.WriteLine(vbTab & "OK")

        StartEpilog()

    End Sub

End Module
